/* implementazione di BubbleSort */

#include <string.h>
#include <stdbool.h>
#include "sort.h"


int string_swap(char s1[], char s2[]) {
  char tmp[129];
  int i;
  
  for(i = 0; i < 129 && s1[i]; i++)
    tmp[i] = s1[i];
  tmp[i] = '\0';
  
  for(i = 0; i < 129 && s2[i]; i++)
    s1[i] = s2[i];
  s1[i] = '\0';
  
  for(i = 0; i < 129 && tmp[i]; i++)
    s2[i] = tmp[i];
  s2[i] = '\0';
}


void sort(char s[][129], int n) {
  bool swap;
  int i, c;
  char tmp[129];
  
  do{
    swap = false;
    for(i = 0; i < n-1; i++)
	  if(strcmp(s[i], s[i+1]) > 0) {
	    string_swap(s[i], s[i+1]);
		swap = true;
	  }
  } while( swap );
}

// versione ottimizzata
// usa l'intero k per limitare i confronti inutili
void sort_opt(char s[][129], int n) {
  bool swap;
  int i, c, k = 0;
  char tmp[129];
  
  do{
    swap = false;
    for(i = 0; i < n-1-k; i++)
	  if (strcmp(s[i], s[i+1]) > 0){
	    string_swap(s[i], s[i+1]);
		swap = true;
	  }
	k++;
  } while( swap );
}
